Subject: Re: Wrong UIDs reported in /proc/net/tcp

From: "Chad N. Tindel" <[email-masked]>
Date: Fri, 19 Nov 2004 16:01:56 -0500

> > OK, so just out of sheer morbid curiousity, I added an ioctl which will
> > accept 4 parameters (the address/port pairs), and will return the user id
> > associated with that socket.  I also changed pidentd to call this ioctl
> > instead of looking at /proc/net/tcp.  This should theoretically get rid
> > of all race conditions.
> 
> Please show us the code of your ioctl.

Hi-

I found the problem... it was a bug in my pidentd changes where I wasn't 
properly handling an ioctl failure.  So, using an ioctl to do a direct hash
table lookup makes the userid mismatches go away.  We've been running tests for
12 hours without any failures.

> Have you tried netlink yet? Does it exhibit the same problem?

Only so many test systems to go around.  ;-)  Will start these tests tonight
and report back.

Chad